/******************************************************************************/
/* COPYRIGHT: Copyright (C) International Business Machines Corp., 1997       */
/*                                                                            */
/* DISCLAIMER OF WARRANTIES:                                                  */
/*   The following [enclosed] code is sample code created by IBM              */
/*   Corporation.  This sample code is not part of any standard IBM product   */
/*   and is provided to you solely for the purpose of assisting you in the    */
/*   development of your applications.  The code is provided "AS IS",         */
/*   without warranty of any kind.  IBM shall not be liable for any damages   */
/*   arising out of your use of the sample code, even if they have been       */
/*   advised of the possibility of such damages.                              */
/******************************************************************************/

import	java.awt.*;
import 	java.awt.event.*;
import	java.applet.Applet;




class FlowLayoutTest extends Frame
				implements WindowListener

{
	private boolean		isApplication = false;
	private Button		button1 = new Button("11111");
	private Button		button2 = new Button("22");
	private Button		button3 = new Button("333");
	private Button		button4 = new Button("44444");
	private Button		button5 = new Button("555");
	private Button		button6 = new Button("6666");
	private Button		button7 = new Button("7777");
	private Button		button8 = new Button("88"); 
	private Panel		flowPanel = new Panel();
	private Panel		buttonPanel = new Panel();
	private FlowLayout	flowLayout = new FlowLayout(FlowLayout.CENTER, 0, 0);
	private Button		vgapPlus = new Button("vgap +");
	private Button		vgapMinus = new Button("vgap -");
	private Button		hgapPlus = new Button("hgap +");
	private Button		hgapMinus = new Button("hgap -");
	private Button		alignLeft = new Button("Left");
	private Button		alignCenter = new Button("Center");
	private Button		alignRight = new Button("Right");

	private int			vgap = 0;
	private int			hgap = 0;

	

	FlowLayoutTest()
	{
		super("FlowLayout Test");

		addWindowListener(this);
		
		flowPanel.setLayout(flowLayout);

		button1.setFont(new Font("Helvetica", Font.PLAIN, 20));
		button2.setFont(new Font("Helvetica", Font.PLAIN, 20));
		button3.setFont(new Font("Helvetica", Font.PLAIN, 36));
		button4.setFont(new Font("Helvetica", Font.PLAIN, 20));
		button5.setFont(new Font("Helvetica", Font.PLAIN, 48));
		button6.setFont(new Font("Helvetica", Font.PLAIN, 20));
		button7.setFont(new Font("Helvetica", Font.PLAIN, 20));
		button8.setFont(new Font("Helvetica", Font.PLAIN, 20));

		flowPanel.add(button1);	
		flowPanel.add(button2);
		flowPanel.add(button3);
		flowPanel.add(button4);
		flowPanel.add(button5);
		flowPanel.add(button6);
		flowPanel.add(button7);
		flowPanel.add(button8);

		buttonPanel.add(vgapPlus);
		buttonPanel.add(vgapMinus);
		buttonPanel.add(hgapPlus);
		buttonPanel.add(hgapMinus);
		buttonPanel.add(alignLeft);
		buttonPanel.add(alignCenter);
		buttonPanel.add(alignRight);

		add("Center", flowPanel);
		add("South", buttonPanel);	

            // Increase vgap
		vgapPlus.addActionListener(
			new ActionListener ()
			{
				public void actionPerformed(ActionEvent e)
				{
					vgap +=5;
					flowLayout.setVgap(vgap);
					flowLayout.layoutContainer(flowPanel);
				}
			}
		);

            // Decrease vgap
		vgapMinus.addActionListener(
			new ActionListener ()
			{
				public void actionPerformed(ActionEvent e)
				{
					if(vgap>5)
						vgap -=5;
					else
						vgap = 0;
					flowLayout.setVgap(vgap);
					flowLayout.layoutContainer(flowPanel);				}
			}
		);

            // Increase hgap
		hgapPlus.addActionListener(
			new ActionListener ()
			{
				public void actionPerformed(ActionEvent e)
				{
					hgap +=5;
					flowLayout.setHgap(hgap);
					flowLayout.layoutContainer(flowPanel);
				}
			}
		);

            // Decrease hgap
		hgapMinus.addActionListener(
			new ActionListener ()
			{
				public void actionPerformed(ActionEvent e)
				{
					if(hgap>5)
						hgap -=5;
					else
						hgap = 0;
					flowLayout.setHgap(hgap);
					flowLayout.layoutContainer(flowPanel);
				}
			}
		);

            // Set Alignment to Left
		alignLeft.addActionListener(
			new ActionListener ()
			{
				public void actionPerformed(ActionEvent e)
				{
					flowLayout.setAlignment(FlowLayout.LEFT);
					flowLayout.layoutContainer(flowPanel);
				}
			}
		);

            // Set Alignment to Center
		alignCenter.addActionListener(
			new ActionListener ()
			{
				public void actionPerformed(ActionEvent e)
				{
					flowLayout.setAlignment(FlowLayout.CENTER);
					flowLayout.layoutContainer(flowPanel);
				}
			}
		);

            // Set Alignment to Right
		alignRight.addActionListener(
			new ActionListener ()
			{
				public void actionPerformed(ActionEvent e)
				{
					flowLayout.setAlignment(FlowLayout.RIGHT);
					flowLayout.layoutContainer(flowPanel);
				}
			}
		);

	}

	public static void main( String args[])
	{
		FlowLayoutTest flowTest = new FlowLayoutTest();
		flowTest.setSize(350, 250);
		flowTest.show();
	}

	public void windowClosing(WindowEvent event)
	{
		System.exit(0);
	}

	public void windowOpened(WindowEvent event) {}
	public void windowClosed(WindowEvent event) {}
	public void windowIconified(WindowEvent event) {}
	public void windowDeiconified(WindowEvent event) {}
	public void windowActivated(WindowEvent event) {}
	public void windowDeactivated(WindowEvent event) {}


}




