/******************************************************************************/
/* COPYRIGHT: Copyright (C) International Business Machines Corp., 1997       */
/*                                                                            */
/* DISCLAIMER OF WARRANTIES:                                                  */
/*   The following [enclosed] code is sample code created by IBM              */
/*   Corporation.  This sample code is not part of any standard IBM product   */
/*   and is provided to you solely for the purpose of assisting you in the    */
/*   development of your applications.  The code is provided "AS IS",         */
/*   without warranty of any kind.  IBM shall not be liable for any damages   */
/*   arising out of your use of the sample code, even if they have been       */
/*   advised of the possibility of such damages.                              */
/******************************************************************************/

import java.awt.*;
import java.awt.event.*;

class BorderTest extends Frame {
  public BorderTest()
  {
    //Set the layout to be border layout with 3 pixels of horizontal gaps and 15 pixels of vertical gap
    //between components.
    setLayout(new BorderLayout(3,15));  
    setTitle("BorderTest");
    
    add("North", new TextField("Text Field in the North"));
    add("South", new TextField("Text Field in the South"));
    add("East", new TextField("Text Field in the East"));
    add("West", new TextField("Text Field in the West"));
    add("Center", new Button("Center Button"));
    class BorderTestAdapter extends WindowAdapter
    {
      public void windowClosing(WindowEvent event) 
      {
        System.exit(0);
      }
    }
    addWindowListener(new BorderTestAdapter());
  }
  
  public static void main(String args[])
  {
    Frame f = new BorderTest();
    f.setSize(500,300);
    f.show();
  }
}
