/******************************************************************************/
/* COPYRIGHT: Copyright (C) International Business Machines Corp., 1997       */
/*                                                                            */
/* DISCLAIMER OF WARRANTIES:                                                  */
/*   The following [enclosed] code is sample code created by IBM              */
/*   Corporation.  This sample code is not part of any standard IBM product   */
/*   and is provided to you solely for the purpose of assisting you in the    */
/*   development of your applications.  The code is provided "AS IS",         */
/*   without warranty of any kind.  IBM shall not be liable for any damages   */
/*   arising out of your use of the sample code, even if they have been       */
/*   advised of the possibility of such damages.                              */
/******************************************************************************/

import java.awt.*;
import java.awt.event.*;

class CardTest extends Frame implements ActionListener {
  private Panel cardPanel;
  private CardLayout cardLayout;
  private Button firstButton;
  private Button nextButton;
  private Button lastButton;
  private Button previousButton;

  public CardTest()
  {           
    setTitle("CardTest");      
    setLayout(new BorderLayout());
    Panel buttonPanel = new Panel();
    
    firstButton = new Button("First");
    nextButton = new Button("Next");
    lastButton = new Button("Last");
    previousButton = new Button("Previous");
    
    buttonPanel.add(firstButton);
    buttonPanel.add(nextButton);
    buttonPanel.add(lastButton);
    buttonPanel.add(previousButton);
    
    firstButton.addActionListener(this);
    nextButton.addActionListener(this);
    lastButton.addActionListener(this);
    previousButton.addActionListener(this);
    add("North", buttonPanel);
    
    cardPanel = new Panel();  
    cardLayout = new CardLayout();
    cardPanel.setLayout(cardLayout);  
    
    Panel p1 = new Panel();
    p1.add(new Label("This is the first Card"));
    p1.add(new TextField("Text Field1"));
    p1.add(new TextField("Text Field2"));
    p1.add(new Button("OK"));
    cardPanel.add("card1", p1);
    
    Panel p2 = new Panel();
    p2.add(new Label("This is the second Card"));
    p2.add(new Checkbox("check me"));
    p2.add(new Button("Cancel"));
    cardPanel.add("card2", p2);
    
    Panel p3 = new Panel();
    p3.setLayout(new BorderLayout());
    p3.add("North", new Label("This is the third Card"));
    p3.add("South", new TextField("Status area"));
    p3.add("Center", new Button("Centered Button"));
    cardPanel.add("card3", p3);
    
    add("Center", cardPanel);
    
    class CardTestAdapter extends WindowAdapter
    {
      public void windowClosing(WindowEvent event) 
      {
        System.exit(0);
      }
    }
    addWindowListener(new CardTestAdapter());
  }
  
  public void actionPerformed(ActionEvent event) 
  {
    if (event.getSource() == firstButton)
    {
      cardLayout.first(cardPanel);
    }
    else if (event.getSource() == nextButton)
    {
      cardLayout.next(cardPanel);
    }
    else if (event.getSource() == lastButton)
    {
      cardLayout.last(cardPanel);
    }
    else if (event.getSource() == previousButton)
    {
      cardLayout.previous(cardPanel);
    }
  }
  
  public static void main(String args[])
  {
    Frame f = new CardTest();
    f.setSize(500,300);
    f.show();
  }
}

