/******************************************************************************/
/* COPYRIGHT: Copyright (C) International Business Machines Corp., 1997       */
/*                                                                            */
/* DISCLAIMER OF WARRANTIES:                                                  */
/*   The following [enclosed] code is sample code created by IBM              */
/*   Corporation.  This sample code is not part of any standard IBM product   */
/*   and is provided to you solely for the purpose of assisting you in the    */
/*   development of your applications.  The code is provided "AS IS",         */
/*   without warranty of any kind.  IBM shall not be liable for any damages   */
/*   arising out of your use of the sample code, even if they have been       */
/*   advised of the possibility of such damages.                              */
/******************************************************************************/

import java.lang.System;


class finallytest 
{
  public int f1()
  {
    return 1;
  }
  
  public int f2()
  {
    try {
      return 2;
    }
    catch(Exception e) {return 3;}
  }
  
  public int f3()
  {
    //Since the finally is always executed whether an exception is thrown or not, this 
    //function will return 4 every time.
    try {
      return 3;
    }
    finally {
      return 4;
    }
  }

  public void f4()
  {
  }
  
  public void f5() throws NullPointerException
  {
    throw new NullPointerException();
  }
  
  public void f6()
  {
  }

  public void f7() throws NoSuchMethodException
  {
    throw new NoSuchMethodException();
  }

  public static void main(String args[])
  {   
    finallytest f = new finallytest();
  
    //===================================================================
    System.out.println("First test: nesting"); 
    //Test to see how try/catch/finally nest
    try {
      System.out.println("In try before calling f5");
      f.f5();
    }
    catch (NullPointerException npe) {
      System.out.println("Caught NullPointerException");
      try {
       System.out.println("In try before calling f7");
       f.f7();
      }
      catch (NoSuchMethodException nsme)  {
        System.out.println("Caught NoSuchMethodException");
      }
      finally {
        System.out.println("Nest test: finally for f7");
      }
    }
    finally {
      System.out.println("Nest test: finally for f5");
    }
    
    //=================================================================
    
    System.out.println("");
    System.out.println("Second test: nesting");
    //Another test to see how try/catch/finally nest
    try {
      System.out.println("In try before calling f5");
      f.f5();
      try {
        System.out.println("In try before calling f7");
        f.f7();
      }
      catch (NoSuchMethodException nsme) {
         System.out.println("Caught NoSuchMethodException");
         }
      finally {
        System.out.println("Nest test: finally for f7");
      }
    }
    catch (NullPointerException npe) {
       System.out.println("Caught NullPointerException");
       }
    finally {
      System.out.println("Nest test: finally for f5");
    }

    //=========================================================================

    System.out.println("");
    System.out.println("Third test: finally with return");                           
    //Test of finally statement with return statement.  Interesting result from f3().
    System.out.println("f1 returns " + f.f1());
    System.out.println("f2 returns " + f.f2());
    System.out.println("f3 returns " + f.f3());
    
    //================================================================================
    
    System.out.println("");
    System.out.println("Fourth test: How are finally statements executed");    
    //Test to see how finally statements are executed.  If an exception is thrown, the finally
    //for the corresponding try is executed, then the code exits.  Only finally statements for
    //executed try statements will execute.
    try {
      System.out.println("In try before calling f4");
      f.f4();
    }
    finally {
      System.out.println("Reached finally for f4");
    }
      
    try {
      System.out.println("In try before calling f5");
      f.f5();
    }
    finally {
      System.out.println("Reached finally for f5"); 
    }
      
    try {
      System.out.println("In try before calling f6");
      f.f6();
    }
    finally {
      System.out.println("Reached finally for f6");
    }
  }
}
