/******************************************************************************/
/* COPYRIGHT: Copyright (C) International Business Machines Corp., 1997       */
/*                                                                            */
/* DISCLAIMER OF WARRANTIES:                                                  */
/*   The following [enclosed] code is sample code created by IBM              */
/*   Corporation.  This sample code is not part of any standard IBM product   */
/*   and is provided to you solely for the purpose of assisting you in the    */
/*   development of your applications.  The code is provided "AS IS",         */
/*   without warranty of any kind.  IBM shall not be liable for any damages   */
/*   arising out of your use of the sample code, even if they have been       */
/*   advised of the possibility of such damages.                              */
/******************************************************************************/

import java.lang.Exception;

class MyException extends Exception
{
  public MyException(String str)
  {
    super(str);
  }
}

class TestClass
{
  public void funcA (String str) throws MyException
  {
    throw new MyException(str);
  }
}

class finallyThrowTest
{
  public static void main (String args[])
  {
    try {
      System.out.println("In outer most try block");
      TestClass t = new TestClass();
      try {
        System.out.println("In inner try block");
        t.funcA("Exception thrown from inner try");
      }
      catch (MyException e1) {
        System.out.println("In inner catch block");
        System.out.println("Exception caught: " + e1.getMessage());
        t.funcA("Exception thrown inner catch");
      }
      finally {
        System.out.println("In inner finally");
        t.funcA("Exception thrown from inner finally");  //Comment this out to unhide 
                                                         //exception thrown from inner catch
      }  
    }
    catch (MyException e2) {
      System.out.println("In outer catch");
      System.out.println("Exception caught: " + e2.getMessage());
    }
    finally {
      System.out.println("In outer finally");
    }
  }
}
