/******************************************************************************/
/* COPYRIGHT: Copyright (C) International Business Machines Corp., 1997       */
/*                                                                            */
/* DISCLAIMER OF WARRANTIES:                                                  */
/*   The following [enclosed] code is sample code created by IBM              */
/*   Corporation.  This sample code is not part of any standard IBM product   */
/*   and is provided to you solely for the purpose of assisting you in the    */
/*   development of your applications.  The code is provided "AS IS",         */
/*   without warranty of any kind.  IBM shall not be liable for any damages   */
/*   arising out of your use of the sample code, even if they have been       */
/*   advised of the possibility of such damages.                              */
/******************************************************************************/

import java.lang.Exception;

class testException extends Exception {
}

class bar { 
  public bar(int i) throws testException
  {
    System.out.println("Attempting to construct bar with: " + new Long(i).toString());
    if (i==3)
      throw new testException();
  }
}

class newFoo {
  private int numberOfBars=0;
  public bar funcA() throws testException
  {
    try { 
      return new bar(numberOfBars++);
    }
    catch (testException e) {
      numberOfBars--;
      throw e;
    }
  }
  public int getNumberOfBars()
  { 
    return numberOfBars;
  }
}

class incOpOKTest {
  public static void main (String args[])
  {
    newFoo f = new newFoo();
    for (int i=0; i<4; i++)
    {
      try {
        bar b = f.funcA();
      }
      catch (testException e) {
        System.out.println("Caught exception, numberOfBars is: " + new Long(f.getNumberOfBars()).toString()); 
      }
      finally {
        System.out.println("In finally, numberOfBars is: " + new Long(f.getNumberOfBars()).toString());
      }
    }
  }
}
