/******************************************************************************/
/* COPYRIGHT: Copyright (C) International Business Machines Corp., 1997       */
/*                                                                            */
/* DISCLAIMER OF WARRANTIES:                                                  */
/*   The following [enclosed] code is sample code created by IBM              */
/*   Corporation.  This sample code is not part of any standard IBM product   */
/*   and is provided to you solely for the purpose of assisting you in the    */
/*   development of your applications.  The code is provided "AS IS",         */
/*   without warranty of any kind.  IBM shall not be liable for any damages   */
/*   arising out of your use of the sample code, even if they have been       */
/*   advised of the possibility of such damages.                              */
/******************************************************************************/

import java.lang.Exception;

class MyCustomException extends Exception {
}
                                                                                                   
class MyCustomException1 extends MyCustomException {
}

class MyCustomException2 extends MyCustomException1 {
}

//Assume this class is part of some library that you don't have the source code for.  You will 
//only know that it throws a MyCustomException because that is all that is advertized.  You
//will not know to try to catch the more specific exceptions thrown by the method.
class lazy
{
  public void foo (int i) throws MyCustomException
  {  
    if (i==0)
      throw new MyCustomException();
    if (i==1)
      throw new MyCustomException1();
    if (i==2)
      throw new MyCustomException2(); 
  }
}

class lazyTest 
{
  public static void main (String args[])
  {          
    lazy l = new lazy(); 
    try {
      l.foo(0);
    }
    //If you had access to the source for the foo method you could catch a more specific
    //exception.  However, who wants to scan source to know what exceptions to catch?
    //They should be listed in the throws clause.
    catch (MyCustomException mce) {
      System.out.println("Caught mce");
    }
  }
}                                                          
